/// Handlers for /help routes
module PrayerTracker.Handlers.Help

open Giraffe
open PrayerTracker

// GET: /help
let index : HttpHandler = fun next ctx -> task {
    return!
        Views.Help.index ()
        |> Views.Layout.help ctx.Strings["Help Index"].Value true
        |> renderHtml next ctx
}

/// Handlers for /help/requests routes
module Requests =
    
    // GET: /help/requests/edit
    let edit : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.Requests.edit ()
            |> Views.Layout.help ctx.Strings["Add / Edit a Request"].Value false
            |> renderHtml next ctx
    }
    
    // GET: /help/requests/maintain
    let maintain : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.Requests.maintain ()
            |> Views.Layout.help ctx.Strings["Maintain Requests"].Value false
            |> renderHtml next ctx
    }
    
    // GET: /help/requests/view
    let view : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.Requests.view ()
            |> Views.Layout.help ctx.Strings["View Request List"].Value false
            |> renderHtml next ctx
    }

/// Handlers for /help/small-group routes
module SmallGroup =
    
    // GET: /help/small-group/announcement
    let announcement : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.SmallGroup.announcement ()
            |> Views.Layout.help ctx.Strings["Send Announcement"].Value false
            |> renderHtml next ctx
    }
    
    // GET: /help/small-group/members
    let members : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.SmallGroup.members ()
            |> Views.Layout.help ctx.Strings["Maintain Group Members"].Value false
            |> renderHtml next ctx
    }
    
    // GET: /help/small-group/members
    let preferences : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.SmallGroup.preferences ()
            |> Views.Layout.help ctx.Strings["Change Preferences"].Value false
            |> renderHtml next ctx
    }

/// Handlers for /help/user routes
module User =
    
    // GET: /help/user/log-on
    let logOn : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.User.logOn ()
            |> Views.Layout.help ctx.Strings["Log On"].Value false
            |> renderHtml next ctx
    }
    
    // GET: /help/user/password
    let password : HttpHandler = fun next ctx -> task {
        return!
            Views.Help.User.password ()
            |> Views.Layout.help ctx.Strings["Change Your Password"].Value false
            |> renderHtml next ctx
    }
